@echo off& setlocal disabledelayedexpansion
set pn=%~n0& set tf1=&set tf2=& if "%~1"=="" goto help

set r=%random%& rem set temp file names; test we can write to temp dir
set tf1="%tmp%\%pn%-%r%a.tmp"& set tf2="%tmp%\%pn%-%r%b.tmp"
type nul>%tf1%& if not exist %tf1% echo %pn%: *** %tf1% error& exit/b

set/a ofc=0,ml=-1& set/a ml=%~1 2>nul
if not "%ml%"=="%~1" echo %pn%: *** bad megabyte limit: %~1& goto exit
if %ml% geq 0 set ofc=1

rem set zo= 7z options (if any).  arg of -- will stop option gathering.
set "zo=-tzip -spf2"& set x=zip
:oz
set "a=x%~2"
if /i "%a:~1,2%"=="-t" set zo=%zo:-tzip=%& set x=%a:~3%
if "%a:~1,1%"=="-" set zo=%zo% %2& shift/2& if not "%a%"=="x--" goto oz

rem insure output file(s) don't exist
set a="%~2*.%x%"& if "%~2"=="" goto help
if exist %a% echo %pn%: *** output file(s) %a% exist& goto exit

rem collect input filenames (and contents of @filelists) into %tf1%
set/p ="%pn%: collecting input info... "<nul
if "%~3"=="" dir /a-d-h/s/b>%tf1%& goto inf_done
:inf
set "a=x%~3"& set t=x%~a3
if "%a:~1,1%"=="@" (
  if "%a:~2%"=="" (find/v "") else find/v ""<"%a:~2%")>>%tf1%& goto inx
set w=& if x%t:~1,1%==xd if "%a%%a%"=="%a:?=%%a:**=%" set w=\*.*
for %%g in ("%~3%w%") do echo %%g>>%tf1%
:inx
if not "%~4"=="" shift/3& goto inf
:inf_done

rem count and validate input files exist and sum input file sizes.
set/a ifc=tm=tmr=e=0,MB=1000000& ver>nul& rem ver 0's errorlevel
for /f "usebackq delims=" %%f in (%tf1%) do (
  set/a a=%%~zf 2>nul& if errorlevel 1 set "f=%%~f"& call :vif_spec %%~zf
  set/a ifc+=1,tmr+=a%%MB,tm+=a/MB+tmr/MB,tmr%%=MB
)
if %e%==1 (goto exit) else goto vif_spec_skip
rem special cases: 1. file not found; 2. file size geq 2**31
:vif_spec
setlocal enabledelayedexpansion& set "a=%1"
if x%1==x (if %e%==0 echo.& set e=1)& echo %pn%: *** not found: !f!
if not x%1==x set/a tm+=!a:~0,-6!& set a=1!a:~-6!-MB
endlocal& set/a a=%a%+0,e=%e%,tm=%tm%& ver>nul& exit/b
:vif_spec_skip

rem output count of files and total bytes
set/a a=tmr,f=tmr+MB
if %tm% geq 1 set a=%tm%%f:~1%
call :nfmt f %ifc% a %a%
echo  %f% files  %a% bytes

echo .>>%tf1%& if %ifc%==0 goto exit
rem create output (note: %tf1% file list is terminated with a .)
if /i "%~2"=="nul" goto exit
setlocal enabledelayedexpansion
set/a m=mr=pm=pmr=p=np=0& if %tm%==0 set p=100
set/p ="%pn%: creating output... "<nul
del %tf2% 2>nul& for /f "usebackq delims=" %%f in (%tf1%) do (
  if "%%f"=="." (set ml=0) else (
    set s=%%~zf& set r=%MB%!s!
    set/a mr+=1!r:~-6!-MB,m+=!s:~0,-6!+mr/MB,mr%%=MB
    setlocal disabledelayedexpansion& echo %%f>>%tf2%& endlocal
  )
  if !ml! geq 0 if !m! geq !ml! if exist %tf2% (
    set fx=&if !ofc! geq 1 set/a fx=ofc,ofc+=1& if !fx! leq 99 (
      set fx=00!fx!& set fx=!fx:~-3!)
    7z a %zo% "%~2!fx!" @%tf2%>nul
    if errorlevel 1 echo.& echo %pn%: *** 7z error& goto exit
    set/a pmr+=mr,pm+=m+pmr/MB,pmr%%=MB,m=mr=0
    if !p! lss 100 set/a p=pm*100/tm& if !p! geq !np! (
      set/p ="!p!%% "<nul& set/a np=p+10& if !np! geq 100 set np=100)
    del %tf2% 2>nul
  )
)
echo.& goto exit

rem Routine to format commas into decimal number (up to 21 digits).
rem %1= output variable name, %2= number to format (leading - allowed)
:nfmt
setlocal enabledelayedexpansion& set n=%2
for /l %%i in (-3,-4,-23) do (
  if not "!n!"=="!n:~%%i!" if not "!n:~0,%%i!"=="-" (
    set n=!n:~0,%%i!,!n:~%%i!)
)
endlocal& set %1=%n%
if not "%~3"=="" (shift& shift& goto nfmt) else exit/b

:help
echo.
echo Compresses files into archives.  PaulHoule.com 2/10/2019.
echo.
echo   nnn      Decimal input size limit in megabytes (-1 for no limit).
echo            When input limit reached a new output archive is started.
echo   {-opts}  Arg(s) here prefixed with hyphen are used as 7zip
echo            options (for example  -mx0  for no compression).
echo   output   Output path and filename -- output files are given
echo            this name postfixed with 001, 002, etc.
echo   {inf}    Input filespecs (eg: *.exe readme.txt) -- if none
echo            uses files in current and sub-directories.
echo            @file uses file as filelist (@ alone uses stdin).
echo.& echo Example 1: create 1 gig archives gig{nnn} w/o compression
echo   %pn% 1000 -mx0 gig *.*
:exit
del %tf1% %tf2% >nul 2>nul
